/*
 File: first_set_rulessym.cpp
 Date and Time: Fri Jan 30 18:55:11 2015 
*/
#include "first_set_rules.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_first_set_rules;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Cfirst_set_rules::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rfirst_set_rules_:{
       Rfirst_set_rules* sym;
     if(re->rule_ == 0){
       sym = new Rfirst_set_rules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfirst_set_rules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_:{
       Rrule* sym;
     if(re->rule_ == 0){
       sym = new Rrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    default: return;
   }
}
